Loading...
Searching...
No Matches
pcl::visualization::Window Class Reference

`#include <pcl/visualization/window.h>`

## Classes

struct | ExitMainLoopTimerCallback
struct | ExitCallback

## Public Member Functions

| Window (const std::string &window_name="")
| Window (const Window &src)
Window & | operator= (const Window &src)
virtual | ~Window ()
void | spin ()
| Spin method.
void | spinOnce (int time=1, bool force_redraw=false)
| Spin once method.
bool | wasStopped () const
| Returns true when the user tried to close the window.
boost::signals2::connection | registerKeyboardCallback (void(*callback)(const pcl::visualization::KeyboardEvent &, void *), void *cookie=nullptr)
| registering a callback function for keyboard events
template<typename T>
boost::signals2::connection | registerKeyboardCallback (void(T::*callback)(const pcl::visualization::KeyboardEvent &, void *), T &instance, void *cookie=nullptr)
| registering a callback function for keyboard events
boost::signals2::connection | registerMouseCallback (void(*callback)(const pcl::visualization::MouseEvent &, void *), void *cookie=nullptr)
template<typename T>
boost::signals2::connection | registerMouseCallback (void(T::*callback)(const pcl::visualization::MouseEvent &, void *), T &instance, void *cookie=nullptr)
| registering a callback function for mouse events

## Protected Member Functions

void | resetStoppedFlag ()
| Set the stopped flag back to false.
boost::signals2::connection | registerMouseCallback (std::function< void(const pcl::visualization::MouseEvent &)>)
| registering a callback function for mouse events
boost::signals2::connection | registerKeyboardCallback (std::function< void(const pcl::visualization::KeyboardEvent &)>)
| registering a callback std::function for keyboard events
void | emitMouseEvent (unsigned long event_id)
void | emitKeyboardEvent (unsigned long event_id)

## Static Protected Member Functions

static void | MouseCallback (vtkObject *, unsigned long eid, void *clientdata, void *calldata)
static void | KeyboardCallback (vtkObject *, unsigned long eid, void *clientdata, void *calldata)

## Protected Attributes

bool | stopped_ {false}
int | timer_id_ {0}
boost::signals2::signal< void(const pcl::visualization::MouseEvent &)> | mouse_signal_
boost::signals2::signal< void(const pcl::visualization::KeyboardEvent &)> | keyboard_signal_
vtkSmartPointer< vtkRenderWindow > | win_
vtkSmartPointer< vtkRenderWindowInteractor > | interactor_
vtkCallbackCommand * | mouse_command_
vtkCallbackCommand * | keyboard_command_
vtkSmartPointer< PCLVisualizerInteractorStyle > | style_
| The render window interactor style.
vtkSmartPointer< vtkRendererCollection > | rens_
| The collection of renderers used.
vtkSmartPointer< ExitMainLoopTimerCallback > | exit_main_loop_timer_callback_
vtkSmartPointer< ExitCallback > | exit_callback_

## Detailed Description

Definition at line 61 of file window.h.

## Constructor & Destructor Documentation

## Window() [1/2]

pcl::visualization::Window::Window | ( | const std::string & | window_name = "" | ) |

Referenced by operator=(), and Window().

## Window() [2/2]

pcl::visualization::Window::Window | ( | const Window & | src | ) |

References Window().

## ~Window()

virtual pcl::visualization::Window::~Window | ( |  | ) |

virtual

## Member Function Documentation

## emitKeyboardEvent()

void pcl::visualization::Window::emitKeyboardEvent | ( | unsigned long | event_id | ) |

protected

## emitMouseEvent()

void pcl::visualization::Window::emitMouseEvent | ( | unsigned long | event_id | ) |

protected

## KeyboardCallback()

void pcl::visualization::Window::KeyboardCallback | ( | vtkObject * | ,
|  | unsigned long | eid,
|  | void * | clientdata,
|  | void * | calldata )

static protected

## MouseCallback()

void pcl::visualization::Window::MouseCallback | ( | vtkObject * | ,
|  | unsigned long | eid,
|  | void * | clientdata,
|  | void * | calldata )

static protected

## operator=()

Window & pcl::visualization::Window::operator= | ( | const Window & | src | ) |

References Window().

## registerKeyboardCallback() [1/3]

boost::signals2::connection pcl::visualization::Window::registerKeyboardCallback | ( | std::function< void(const pcl::visualization::KeyboardEvent &)> |  | ) |

protected

registering a callback std::function for keyboard events

Returns
  connection object that allows to disconnect the callback function.

## registerKeyboardCallback() [2/3]

boost::signals2::connection pcl::visualization::Window::registerKeyboardCallback | ( | void(* | callback )(const pcl::visualization::KeyboardEvent &, void *),
|  | void * | cookie = nullptr )

inline

registering a callback function for keyboard events

Parameters

  callback | the function that will be registered as a callback for a keyboard event
  cookie | user data that is passed to the callback

Returns
  connection object that allows to disconnect the callback function.

Definition at line 93 of file window.h.

References registerKeyboardCallback().

Referenced by registerKeyboardCallback(), and registerKeyboardCallback().

## registerKeyboardCallback() [3/3]

template<typename T>

boost::signals2::connection pcl::visualization::Window::registerKeyboardCallback | ( | void(T::* | callback )(const pcl::visualization::KeyboardEvent &, void *),
|  | T & | instance,
|  | void * | cookie = nullptr )

inline

registering a callback function for keyboard events

Parameters

  callback | the member function that will be registered as a callback for a keyboard event
  instance | instance to the class that implements the callback function
  cookie | user data that is passed to the callback

Returns
  connection object that allows to disconnect the callback function.

Definition at line 107 of file window.h.

References registerKeyboardCallback().

## registerMouseCallback() [1/3]

boost::signals2::connection pcl::visualization::Window::registerMouseCallback | ( | std::function< void(const pcl::visualization::MouseEvent &)> |  | ) |

protected

registering a callback function for mouse events

Returns
  connection object that allows to disconnect the callback function.

## registerMouseCallback() [2/3]

boost::signals2::connection pcl::visualization::Window::registerMouseCallback | ( | void(* | callback )(const pcl::visualization::MouseEvent &, void *),
|  | void * | cookie = nullptr )

inline

Parameters

  callback | the function that will be registered as a callback for a mouse event
  cookie | user data that is passed to the callback

Returns
  connection object that allows to disconnect the callback function.

Definition at line 120 of file window.h.

References registerMouseCallback().

Referenced by registerMouseCallback(), and registerMouseCallback().

## registerMouseCallback() [3/3]

template<typename T>

boost::signals2::connection pcl::visualization::Window::registerMouseCallback | ( | void(T::* | callback )(const pcl::visualization::MouseEvent &, void *),
|  | T & | instance,
|  | void * | cookie = nullptr )

inline

registering a callback function for mouse events

Parameters

  callback | the member function that will be registered as a callback for a mouse event
  instance | instance to the class that implements the callback function
  cookie | user data that is passed to the callback

Returns
  connection object that allows to disconnect the callback function.

Definition at line 134 of file window.h.

References registerMouseCallback().

## resetStoppedFlag()

void pcl::visualization::Window::resetStoppedFlag | ( |  | ) |

inline protected

Set the stopped flag back to false.

Definition at line 144 of file window.h.

References stopped_.

## spin()

void pcl::visualization::Window::spin | ( |  | ) |

Spin method.

Calls the interactor and runs an internal loop.

## spinOnce()

void pcl::visualization::Window::spinOnce | ( | int | time = 1,
|  | bool | force_redraw = false )

Spin once method.

Calls the interactor and updates the screen once.

Parameters

  time | - How long (in ms) should the visualization loop be allowed to run.
  force_redraw | - if false it might return without doing anything if the interactor's framerate does not require a redraw yet.

## wasStopped()

bool pcl::visualization::Window::wasStopped | ( |  | ) | const

inline

Returns true when the user tried to close the window.

Definition at line 84 of file window.h.

References stopped_.

## Member Data Documentation

## exit_callback_

vtkSmartPointer<ExitCallback> pcl::visualization::Window::exit_callback_

protected

Definition at line 222 of file window.h.

## exit_main_loop_timer_callback_

vtkSmartPointer<ExitMainLoopTimerCallback> pcl::visualization::Window::exit_main_loop_timer_callback_

protected

Definition at line 221 of file window.h.

## interactor_

vtkSmartPointer<vtkRenderWindowInteractor> pcl::visualization::Window::interactor_

protected

Definition at line 214 of file window.h.

## keyboard_command_

vtkCallbackCommand* pcl::visualization::Window::keyboard_command_

protected

Definition at line 216 of file window.h.

## keyboard_signal_

boost::signals2::signal<void (const pcl::visualization::KeyboardEvent&)> pcl::visualization::Window::keyboard_signal_

protected

Definition at line 211 of file window.h.

## mouse_command_

vtkCallbackCommand* pcl::visualization::Window::mouse_command_

protected

Definition at line 215 of file window.h.

## mouse_signal_

boost::signals2::signal<void (const pcl::visualization::MouseEvent&)> pcl::visualization::Window::mouse_signal_

protected

Definition at line 210 of file window.h.

## rens_

vtkSmartPointer<vtkRendererCollection> pcl::visualization::Window::rens_

protected

The collection of renderers used.

Definition at line 220 of file window.h.

## stopped_

bool pcl::visualization::Window::stopped_ {false}

protected

Definition at line 206 of file window.h.

Referenced by resetStoppedFlag(), and wasStopped().

## style_

vtkSmartPointer<PCLVisualizerInteractorStyle> pcl::visualization::Window::style_

protected

The render window interactor style.

Definition at line 218 of file window.h.

## timer_id_

int pcl::visualization::Window::timer_id_ {0}

protected

Definition at line 207 of file window.h.

## win_

vtkSmartPointer<vtkRenderWindow> pcl::visualization::Window::win_

protected

Definition at line 213 of file window.h.

The documentation for this class was generated from the following file:

- pcl/visualization/window.h